'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _permit = require('./permit');

var _permit2 = _interopRequireDefault(_permit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A basic authorization permit class.
 *
 * @type {Basic}
 */

class Basic extends _permit2.default {
  constructor(options = {}) {
    const scheme = 'Basic';
    super(_extends({ scheme }, options));
  }

  check(req) {
    const { proxy } = this;
    const auth = req.headers ? proxy ? req.headers['proxy-authorization'] : req.headers.authorization : null;

    if (auth) {
      const [scheme, credentials] = auth.split(' ');

      if (scheme === 'Basic') {
        const ascii = Buffer.from(credentials, 'base64').toString('ascii');
        const [username, password] = ascii.split(':');
        return [username, password];
      }
    }
  }
}

/**
 * Export.
 *
 * @type {Basic}
 */

exports.default = Basic;